/* Modified execgem.c by Juergen Lock
 */

#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <errno.h>
#include <mintbind.h>
#include <basepage.h>
#include <st-out.h>

#define init_prg "/usr/multitos/gem.sys"
#define init_tail "\0"
#define init_env 0L

# define BUF	0x100

int
main(int argc, char **argv)
{
	struct stat sb, st;
	long pgrp, r;
	char tmp[BUF];

	if (Fcntl(-1, &pgrp, TIOCGPGRP) ||
		Fcntl(-1, &sb, FSTAT) ||
		(Fxattr(0, "u:\\dev\\ttyv0", &st) &&
		Fxattr(0, "u:\\dev\\vt00", &st) &&
		Fxattr(0, "u:\\dev\\console", &st)) ||
		((st.st_dev != sb.st_dev || st.st_ino != sb.st_ino) &&
		(Fxattr(0, "u:\\dev\\fasttext", &st) ||
		st.st_dev != sb.st_dev || st.st_ino != sb.st_ino)))
	{
		Cconws ("Hey GEM is not X! :)  console only...\r\n");
		return 1;
	}

	/* Set default umask */
	Pumask(0022);

	/* just to be sure... */
	(void) Fclose (0);
	(void) Fcntl(-1, 0L, F_DUPFD);
	(void) Fclose (1);
	(void) Fcntl(-1, 0L, F_DUPFD);
	(void) Fclose (2);
	(void) Fcntl(-1, 0L, F_DUPFD);

	/* `turn off' job control on /dev/console, GEM seems to have
	 *  problems with it...  apparently even multitos :-(
	 */
	r = 0;
	(void) Fcntl(0, &r, TIOCSPGRP);

	/* not Pexec so init_prg gets ARGV and can be a script.
	 */
	execl (init_prg, init_prg, (char *)0);
	if (errno == ENOEXEC)
		execl ("/bin/sh", "/bin/sh", init_prg, (char *)0);
	r = errno;
	snprintf (tmp, BUF, "exec %s failed: %s (%d)\r\n",
		init_prg, strerror (r), (int) r);
	(void) Fcntl(0, &pgrp, TIOCSPGRP);
	Cconws (tmp);
	return r;
}
